//
//  MyDocument.m
//  EasyHash
//
//  Created by Peter Hosey on 2007-03-29.
//  Copyright Peter Hosey 2007 . All rights reserved.
//

#import "MyDocument.h"

@implementation MyDocument

- (NSString *)windowNibName {
	return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
}

- (NSString *) MD5Sum {
	return MD5Sum;
}
- (void) setMD5Sum:(NSString *)newMD5Sum {
	if(MD5Sum != newMD5Sum) {
		[MD5Sum release];
		MD5Sum = [newMD5Sum copy];
	}
}

- (NSString *) SHA1Sum {
	return SHA1Sum;
}
- (void) setSHA1Sum:(NSString *)newSHA1Sum {
	if(SHA1Sum != newSHA1Sum) {
		[SHA1Sum release];
		SHA1Sum = [newSHA1Sum copy];
	}
}

- (BOOL)readFromURL:(NSURL *)absoluteURL ofType:(NSString *)typeName error:(NSError **)outError {
	NSTask *MD5Task  = [[[NSTask alloc] init] autorelease];
	NSTask *SHA1Task = [[[NSTask alloc] init] autorelease];

	NSString *inputFilePath = [absoluteURL path];
	NSFileHandle *MD5StdinFH = [NSFileHandle fileHandleForReadingAtPath:inputFilePath];
	[MD5Task setStandardInput:MD5StdinFH];
	NSFileHandle *SHA1StdinFH = [NSFileHandle fileHandleForReadingAtPath:inputFilePath];
	[SHA1Task setStandardInput:SHA1StdinFH];

	NSPipe *MD5StdoutPipe = [NSPipe pipe];
	[MD5Task setStandardOutput:MD5StdoutPipe];
	NSPipe *SHA1StdoutPipe = [NSPipe pipe];
	[SHA1Task setStandardOutput:SHA1StdoutPipe];

	[MD5Task setLaunchPath:@"/usr/bin/openssl"];
	[MD5Task setArguments:[NSArray arrayWithObject:@"md5"]];

	[SHA1Task setLaunchPath:@"/usr/bin/openssl"];
	[SHA1Task setArguments:[NSArray arrayWithObject:@"sha1"]];

	[MD5Task launch];
	[SHA1Task launch];

	NSData *MD5Data = [[MD5StdoutPipe fileHandleForReading] readDataToEndOfFile];
	[self setMD5Sum:[[[[NSString alloc] initWithData:MD5Data encoding:NSASCIIStringEncoding] autorelease] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]]];

	NSData *SHA1Data = [[SHA1StdoutPipe fileHandleForReading] readDataToEndOfFile];
	[self setSHA1Sum:[[[[NSString alloc] initWithData:SHA1Data encoding:NSASCIIStringEncoding] autorelease] stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]]];

	[MD5Task waitUntilExit];
	[SHA1Task waitUntilExit];

	return (MD5Sum != nil) && (SHA1Sum != nil) && ([MD5Task terminationStatus] == EXIT_SUCCESS) && ([SHA1Task terminationStatus] == EXIT_SUCCESS);
}
- (BOOL)writeToURL:(NSURL *)absoluteURL ofType:(NSString *)typeName error:(NSError **)outError {
	return NO;
}

@end
